#include "at32f403a_407.h"
#include "modbus_params.h"
#include <string.h>


mb_param_t mb_param[MB_PARAM_MAX];
uint16_t psw; // Пароль для установки системных настроек
bool psw_ok = false;
bool set_sys_settings_flag = false;
//sys_settings_t temp_sys_settings;
uint16_t temp_modbus_port;
uint16_t temp_reley;
const float null_float = 0.0;


uint32_t u32_param = 123456789;
uint16_t u16_param = 32768;
float f_param = 1.23456;



//
void mb_init_params(void)
{
    mb_param[0].reg = 0x30;
	mb_param[0].size = 2;
	mb_param[0].param = (uint8_t*)&u32_param;
	mb_param[0].set_handler = NULL;
    mb_param[0].check_handler = mb_check_dummy;
    
    mb_param[1].reg = 0x32;
	mb_param[1].size = 1;
	mb_param[1].param = (uint8_t*)&u16_param;
	mb_param[1].set_handler = NULL;
    mb_param[1].check_handler = mb_check_dummy;
    
    mb_param[2].reg = 0x33;
	mb_param[2].size = 2;
	mb_param[2].param = (uint8_t*)&f_param;
	mb_param[2].set_handler = NULL;
    mb_param[2].check_handler = mb_check_dummy;
}

// Возвращает размер параметра в регистрах
bool mb_find_param(uint16_t reg, uint16_t *index, uint16_t *size)
{
	for (uint16_t i = 0; i < MB_PARAM_MAX; i++)
	{
		if (mb_param[i].reg == reg)
		{
			*index = i;
			*size = mb_param[i].size;
			return true;
		}
	}
	return false;
}


//
mb_delay_action_t mb_set_param(uint8_t *buf, uint16_t index)
{
	uint8_t *ptr = mb_param[index].param;

    // Если параметр только для чтения
    if (mb_param[index].check_handler == NULL)
        return MB_NO_ACTION;
    
	for (uint16_t i = 0; i < 2*mb_param[index].size; i++)
	{
		*ptr = buf[2*mb_param[index].size - 1 - i];
		ptr++;
	}
  
/*    
    if (mb_param[index].check_handler != NULL)
        mb_param[index].check_handler();
*/    
    
    mb_param[index].check_handler();
    
    if (mb_param[index].set_handler != NULL)
        return mb_param[index].set_handler();
    else
        return MB_NO_ACTION;
    
/*    
    if (mb_param[index].f_activity)
        return mb_param[index].set_handler();
    else
        return MB_NO_ACTION;
*/    
}


//
void mb_get_param(uint8_t *buf, uint16_t index)
{
	uint8_t *ptr = mb_param[index].param + 2*mb_param[index].size - 1;

	for (uint16_t i = 0; i < 2*mb_param[index].size; i++)
	{
		*buf = *ptr;
		buf++;
		ptr--;
	}

}




//
uint8_t mb_get_info(uint8_t *buf)
{
	char id_str[9] = {0};
    char model[6] = {0};
	uint32_t id_word;
	uint8_t ret = 0;	// длина пакета
	uint8_t len;

    len = strlen("Hello world");
    *buf++ = len;
    strcpy(buf, "Hello world");
    buf += len;
    ret = 1 + len;
      
#if 0    
	// ------------------------------------------------------------------- //
	// Model
	// ------------------------------------------------------------------- //
    sprintf(model, "%u", sys_settings.model);
    len = strlen(model); 
    *buf++ = len; // Model len
    memcpy(buf, model, len);
    buf += len;
    ret = 1 + len;

	// ------------------------------------------------------------------- //
	// FW version
	// ------------------------------------------------------------------- //
	*buf++ = 8; // FW version len
	memcpy(buf, sys_settings.fw_version, 8);
	buf += 8;
	ret += 9;

	// ------------------------------------------------------------------- //
	// Stm ID
	// ------------------------------------------------------------------- //
	*buf++ = 24; // STM ID len
	id_word = HAL_GetUIDw0();
	sprintf(id_str, "%08X", id_word);
	len = strlen(id_str);
	memcpy(buf, id_str, len);
	buf += len;
	ret += len;
	memset(id_str, 0, 9);
		
	id_word = HAL_GetUIDw1();
	sprintf(id_str, "%08X", id_word);
	len = strlen(id_str);
	memcpy(buf, id_str, len);
	buf += len;
	ret += len;
	memset(id_str, 0, 9);
	
	id_word = HAL_GetUIDw2();
	sprintf(id_str, "%08X", id_word);
	len = strlen(id_str);
	memcpy(buf, id_str, len);
	buf += len;
	ret += len;

	// ------------------------------------------------------------------- //	
	// Серийник
	// ------------------------------------------------------------------- //
	id_word = sys_settings.serial;
	sprintf(id_str, "%u", id_word);
	len = strlen(id_str);
	*buf++ = len;
	memcpy(buf, id_str, len);
	ret += len;
#endif
	return ret;
}




// -------------------------------------------------------------------------- //
//                      Проверка параметров                                   //
// -------------------------------------------------------------------------- //

//
void mb_check_dummy(void)
{
}



